/* 
 * Compile with:
 * gcc -O $(pkg-config --cflags --libs sp_timestamp) -o timestamps timestamps.c
 * 
 * Test with:
 * $ strace -f -ttt -e trace=open,execve ./timestamps 2>&1 |grep /tmp/stamps
 * 1228750649.955296 open("/tmp/stamps/timestamps:something-important-start",...
 * 1228750649.955389 open("/tmp/stamps/timestamps:something-important-end",...
 * 
 * Or if /tmp/stamps/ exists:
 * $ ls -clrt /tmp/stamps/|awk '{print $8, $9}' 
 * 14:39 timestamps:something-important-start
 * 14:39 timestamps:something-important-end
 */
#include <stdio.h>
#include <unistd.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "sp_timestamp.h"
int main()
{
	char filename[PATH_MAX];
	int fd, count;

	sp_timestamp("print-process-command-name-start");

	/* print process command name */
	fd = open("/proc/self/cmdline", O_RDONLY);
	count = read(fd, filename, sizeof(filename));
	filename[sizeof(filename)-1] = '\0';
	fprintf(stderr, "My path is '%s'\n", filename);
	close(fd);
		
	sp_timestamp("print-process-command-name-end");
	sleep(1);
	
	fprintf(stderr, "Test short string...\n");
	sp_timestamp("short");
	
	fprintf(stderr, "Test long string...\n");
	sp_timestamp("string-with-wierd-chars-12332454-?=_:;!#%&(){}[]-öäÖÄ*-foobar-test-ends-now-really-dsfagewrwetdsfdsf-fghrtertewrewr-cvxcvsdfdsf-wertewr-gdsfdscvbcxvsdfdsf-dsfsdfwerewr-dfgdxfcxbcxvxc-sdfsdf-fdghfdg");
	
	return 0;
}
